function AsyncJob(_1){
this.lastUpdateTime=0;
this.broker=_1;
this._operationInProgress=false;
this.onError=null;
this.onSuccess=null;
var _2=this;
this.broker.onSuccess=function(_3){
_2.handleSuccessResponse(_3);
};
this.broker.onError=function(_4){
_2.handleErrorResponse(_4);
};
};
AsyncJob.prototype.startAsync=function(_5,_6,_7){
this.progressHandler=_6;
if(this._operationInProgress){
this.showProgress();
AsyncJob.log.debug("Operation is already in progress.");
return;
}
var _8=new Date().getTime();
if(_7||this.lastUpdateTime+AsyncJob.INTERVAL<_8){
this.showProgress();
return this._brokerStartAsync(_5);
}
return true;
};
AsyncJob.prototype._brokerStartAsync=function(_9){
this._operationInProgress=true;
return this.broker.startAsync(_9);
};
AsyncJob.prototype.getBroker=function(){
return this.broker;
};
AsyncJob.prototype.cancel=function(){
AsyncJob._showProgressOnPage(false);
};
AsyncJob._showProgressOnPage=function(_a){
$("menu_refresh_img").show(_a);
var _b=$("right_menu_about");
_b.setClassName("loading_landscape",_a);
};
AsyncJob.prototype.showProgress=function(_c){
if(this.progressHandler){
if(_c==null){
_c=true;
}
if(AsyncJob.log.isDebugEnabled()){
AsyncJob.log.debug("showProgress "+_c);
}
if(_c){
AsyncJob._showProgressOnPage(true);
this._updateProgress(StringTable.Downloading,null);
}
}
};
AsyncJob.prototype._updateProgress=function(_d,_e){
if(this.progressHandler&&this.progressHandler.isActive()){
Utils.updateStatusLabels(_d,_e);
}
};
AsyncJob.prototype.handleSuccessResponse=function(_f,_10){
this._operationInProgress=false;
if(this.onSuccess){
this.onSuccess.call(this,_f,_10);
}
if(!this._operationInProgress&&this.progressHandler&&this.progressHandler.isActive()){
AsyncJob._showProgressOnPage(false);
}
if(!_10){
this.lastUpdateTime=new Date().getTime();
}
if(this.progressHandler&&this.progressHandler.setLastUpdatedTime){
var _11=(this.lastUpdateTime)?new Date():null;
if(_11){
_11.setTime(this.lastUpdateTime);
}
this.progressHandler.setLastUpdatedTime(_11,!this._operationInProgress);
}
};
AsyncJob.prototype.handleErrorResponse=function(_12){
this._operationInProgress=false;
if(this.onError){
this.onError.call(this,_12);
}
if(this.progressHandler&&this.progressHandler.isActive()){
AsyncJob._showProgressOnPage(false);
Utils.updateStatusLabelError(_12);
}
};
AsyncJob.log=Logger.getLogger("AsyncJob");
AsyncJob.INTERVAL=300000;
