function SecurityStorage(){
this.securities=null;
};
SecurityStorage.prototype.findSecurityIndex=function(_1){
var _2=-1;
for(var i=0;i<this.securities.length;++i){
if(this.securities[i].pxWBTKR==_1){
_2=i;
break;
}
}
return _2;
};
SecurityStorage.prototype.deleteSecurity=function(_4){
var _5=this.findSecurityIndex(_4);
if(_5>=0){
this.securities.splice(_5,1);
}
};
SecurityStorage.prototype.updateSecurity=function(_6,_7,_8){
var _9=this.findSecurityIndex(_6);
if(_7>=0){
this.securities[_9].position=_7;
this.securities[_9].price=_8;
}
};
SecurityStorage.prototype.addSecurity=function(_a,_b,_c){
var _d=this.findSecurityIndex(_a);
if(_d>=0){
return;
}
var _e={pxWBTKR:_a,position:_b,price:_c};
this.securities.push(_e);
};
SecurityStorage.prototype.getSecurity=function(_f){
var idx=this.findSecurityIndex(_f);
return this.securities[idx];
};
SecurityStorage.prototype.size=function(){
return this.securities.length;
};
SecurityStorage.prototype.get=function(idx){
return this.securities[idx];
};
SecurityStorage.prototype.save=function(){
var _12=null;
try{
_12=JSON.stringify(this.securities);
}
catch(err){
SecurityStorage.log.error("Unable to stringify securities data",err);
}
if(_12){
window.widget.setPreferenceForKey(_12,SecurityStorage.WIDGET_STORAGE_KEY);
}
};
SecurityStorage.prototype.load=function(){
var _13=window.widget.preferenceForKey(SecurityStorage.WIDGET_STORAGE_KEY);
if(!_13){
_13=SecurityStorage.DEFAULTS;
}
this.securities=JSON.parse(_13);
if(this.securities==null){
this.securities=[];
}
};
SecurityStorage.log=Logger.getLogger("SecurityStorage");
SecurityStorage.WIDGET_STORAGE_KEY="blmbrg.securities";
SecurityStorage.DEFAULTS="[ { pxWBTKR: \"NOK1V:FH\", position: 0, price: 0 } ]";
