function XmlRequestBroker(){
this.broker=new RequestBroker();
var _1=this;
this.broker.onSuccess=function(_2){
var _3=_2.responseXML;
if(!_3){
try{
XmlRequestBroker.log.warn("Expecting xml document but responseXML is not set.");
_3=new DOMParser().parseFromString(_2.responseText,"text/xml");
}
catch(err){
XmlRequestBroker.log.error("Parsing xml text failed.",err);
_3=null;
}
}
if(!_3){
_1.onError.call(_1,500);
}else{
var _4=_1._parseXml(_3.firstChild);
_1.onSuccess(_4);
_4=null;
}
};
this.broker.onError=function(_5){
_1.onError.call(_1,_5);
};
this.onSuccess=null;
this.onError=null;
};
XmlRequestBroker.prototype.startAsync=function(_6){
this.broker.startAsync(_6);
};
XmlRequestBroker.prototype.cancel=function(){
this.broker.cancel();
};
XmlRequestBroker.prototype._parseXml=function(_7){
if(_7==null){
return [];
}
if(_7.nodeType==Node.TEXT_NODE){
if(_7.nextSibling==null||_7.nextSibling.nodeType==Node.TEXT_NODE){
var _8="";
while(_7!=null){
if(_7.nodeType==Node.TEXT_NODE){
_8+=_7.nodeValue;
}else{
XmlRequestBroker.log.warn("Text child nodes shouldn't contain other siblings than text: "+_7.nodeType);
break;
}
_7=_7.nextSibling;
}
if(_7==null){
return {leaf:true,value:_8};
}
}
}
var _9={};
while(_7!=null){
if(_7.nodeType==Node.ELEMENT_NODE){
var _a=_7.nodeName.replace(/:/g,"");
var rv=this._parseXml(_7.firstChild);
if(rv&&rv.leaf){
if(XmlRequestBroker.log.isDebugEnabled()){
XmlRequestBroker.log.debug(_a+"="+rv.value);
}
_9[_a]=rv.value;
}else{
rv.__attributes__=[];
for(var i=0;i<_7.attributes.length;++i){
var _d=_7.attributes.item(i);
rv.__attributes__[_d.nodeName.toLowerCase()]=_d.nodeValue;
}
rv.getAttribute=function(_e){
return this.__attributes__[_e];
};
if(_9[_a]==null){
_9[_a]=[rv];
}else{
_9[_a].push(rv);
}
}
}
_7=_7.nextSibling;
}
return _9;
};
XmlRequestBroker.log=Logger.getLogger("XmlRequestBroker");
