function MarketsPage(_1){
MarketsPage.baseConstructor.call(this,_1.pageId,"overflow");
this._page=_1;
this._table=new DynamicHeaderTable(this,_1.tableId,_1.columns);
this._table.setShowArrow(_1.activeRows);
this.updateManager=new BAsyncJob(new XmlRequestBroker());
var _2=this;
this.updateManager.onSuccess=function(_3){
_2.refreshDisplay(_3);
};
this.updateManager.onError=function(_4){
_2.handleErrorResponse(_4);
};
};
Helper.extend(MarketsPage,FormWithBack);
MarketsPage._getCountry=function(_5,_6){
return "<div class='market_flag'><img src='"+Flags.getFlagPath(_5)+"'></img></div><div class='market_name'>"+_6+"</div>";
};
MarketsPage.prototype.onActivated=function(){
var id;
switch(this.id){
case "world_market":
id=AppStats.AppId.MKT_EQUITY_VIEW;
break;
case "world_commodity":
id=AppStats.AppId.MKT_COMMODITY_VIEW;
break;
case "markets_bonds_page":
id=AppStats.AppId.MKT_BOND_VIEW;
break;
case "world_currencies_page":
id=AppStats.AppId.MKT_CURRENCY_VIEW;
break;
}
if(id){
AppStats.inc(id);
}else{
MarketsPage.log.error("Invalid page id specified!");
}
MarketsPage.base.onActivated.call(this);
this.updateManager.startAsync("worldmarketservice.asmx/"+this._page.serviceName,this);
};
MarketsPage.prototype.onDeactivated=function(){
this.updateManager.cancel();
MarketsPage.base.onDeactivated.call(this);
};
MarketsPage.prototype.handleErrorResponse=function(_8){
};
MarketsPage.prototype._createGroup=function(_9){
var tr=document.createElement("tr");
tr.className="table_sub_title";
var td=document.createElement("td");
td.colSpan=4;
td.innerHTML=_9;
tr.appendChild(td);
return this._table.addCustomRow(tr,null,null,false);
};
MarketsPage.prototype._fillGroup=function(_c){
this._createGroup(_c.Description);
var _d=_c.Securities[0].Security;
for(var i=0;i<_d.length;++i){
var _f=_d[i];
MarketsPage._convertValues2Object(_f);
var row=this._table.addRow(_f);
if(this._page.activeRows){
row.onclicked=function(){
AppStats.inc(AppStats.AppId.Q_SUMMARY_VIEW_FROM_MKT);
var _11=uiManager.get("stocks_full");
_11.display(this._item.Id);
};
}
}
};
MarketsPage._convertValues2Object=function(_12){
var _13=_12.Values[0].SerializableStringPair;
for(var i=0;i<_13.length;++i){
var _15=_13[i];
var _16=_15.key.replace(/:/,"");
_12[_16]=_15.value;
}
delete _12.Values;
};
MarketsPage.prototype.refreshDisplay=function(xml){
this._table.clearRows();
this.removeInjectedMenuItems();
if(this._page.onAfterDataReceived){
this._page.onAfterDataReceived.call(this._table,this._table,xml);
}
var _18=xml.WMData[0].Groups[0].Group;
for(var i=0;i<_18.length;++i){
this._fillGroup(_18[i]);
}
};
MarketsPage.log=Logger.getLogger("MarketsPage");
