function MyStocks(){
MyStocks.baseConstructor.call(this,"my_stocks","overflow");
this.updateManager=new BAsyncJob(new XmlRequestBroker());
this.updateManager.enableCache();
this.updateManager.setCacheFilter(MyStocks._cacheFilter);
var _1=this;
this.updateManager.onSuccess=function(_2,_3){
_1.refreshDisplay(_2,_3);
};
this.updateManager.onError=function(_4){
_1.handleErrorResponse(_4);
};
this.mySecurities=new SecurityStorage();
this.myStocksEditBtn=this.add("my_stocks_edit_btn");
this.myStocksEditBtn.onclicked=function(){
var _5=_1.parent.get("my_stocks_edit");
_5.display();
};
this._initTable();
};
Helper.extend(MyStocks,FormWithBack);
MyStocks._cacheFilter=function(_6){
var _7=_6.pxMarketData[0].pxCalcrt[0].pxSecurity;
var rv=[];
if(!_7){
MyStocks.log.debug("MyStocks page is empty.");
}else{
for(var i=0;i<_7.length;++i){
var _a=_7[i];
var _b={};
for(var n in _a){
var o=_a[n];
if(typeof o!=="function"&&n&&n.length>0&&n.charAt(0)!=="_"){
_b[n]=o;
}
}
rv.push(_b);
}
}
return rv;
};
MyStocks.prototype._initTable=function(){
var _e=this;
var _f=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.MyStocks.Name,function(td,_11){
td.innerHTML=_11.pxDS520;
}),new DynamicHeaderTable.Column(StringTable.MyStocks.Ticker,function(td,_13){
td.innerHTML=_13.pxWBTKR;
})]);
var _14=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.MyStocks.Last,function(td,_16){
td.className="";
Utils.assignFormattedNumber(td,_16.pxPR005,2);
}),new DynamicHeaderTable.Column(StringTable.MyStocks.Value,function(td,_18){
var _19=_e.mySecurities.getSecurity(_18.pxWBTKR);
var val=(_19.position==0)?"":parseFloat(_18.pxPR005)*_19.position;
Utils.assignFormattedNumber(td,val,2,Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.MyStocks.ValueChg,function(td,_1c){
var _1d=_e.mySecurities.getSecurity(_1c.pxWBTKR);
var val=(_1d.position==0)?"":parseFloat(_1c.pxPR051)*_1d.position;
Utils.assignFormattedNumber(td,val,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.MyStocks.Position,function(td,_20){
var _21=_e.mySecurities.getSecurity(_20.pxWBTKR);
td.className="";
var val=(_21.position==0)?"":_21.position;
Utils.assignFormattedNumber(td,val,0,Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.MyStocks.BoughtAt,function(td,_24){
var _25=_e.mySecurities.getSecurity(_24.pxWBTKR);
td.className="";
var val=(_25.price==0)?"":_25.price;
Utils.assignFormattedNumber(td,val,2);
}),new DynamicHeaderTable.Column(StringTable.MyStocks.P_L,function(td,_28){
var _29=_e.mySecurities.getSecurity(_28.pxWBTKR);
var val="";
if(_29.price!=0&&_29.position!=0){
val=(parseFloat(_28.pxPR005)-_29.price)*_29.position;
}
td.className="";
Utils.assignFormattedNumber(td,val,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
})]);
var _2b=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.MyStocks.PercentChange,function(td,_2d){
Utils.assignFormattedNumber(td,_2d.pxPR052,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.MyStocks.Change,function(td,_2f){
Utils.assignFormattedNumber(td,_2f.pxPR051,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.MyStocks.Time,function(td,_31){
td.className="";
td.innerHTML=Utils.date2String(_31.pxUTIME);
})]);
this._table=new DynamicHeaderTable(this,"my_stocks_table_message",[_f,_14,_2b],this.myStocksEditBtn);
};
MyStocks.prototype.setForceRefresh=function(){
this._forceRefresh=true;
};
MyStocks.prototype.displayDetails=function(){
var _32=this.parent.get("stocks_full");
_32.display(this.activeItem._item.pxWBTKR);
};
MyStocks.prototype.handleErrorResponse=function(_33){
};
MyStocks.prototype.refreshDisplay=function(_34,_35){
this._table.clearRows();
this.removeInjectedMenuItems();
var _36=$("my_stocks_table_message");
var _37=this;
for(var i=0;i<_34.length;++i){
var _39=_34[i];
var row=this._table.addRow(_39);
row.onclicked=function(){
AppStats.inc(AppStats.AppId.Q_SUMMARY_VIEW_FROM_MY_STOCKS);
_37.displayDetails();
};
}
};
MyStocks.buildRequest=function(_3b){
var _3c={path:"apps/wds/SecurityData.asp",query:{Outfields:"WBTKR,UTIME,DS520,PR005,PR051,PR052",Securities:""}};
for(var i=0;i<_3b.size();++i){
if(i>0){
_3c.query.Securities+=",";
}
_3c.query.Securities+=_3b.get(i).pxWBTKR;
}
return _3c;
};
MyStocks.prototype.onActivated=function(){
this.clearHistory();
this.mySecurities.load();
this.mySecurities.load=function(){
};
AppStats.inc(AppStats.AppId.MY_STOCKS_MAIN_VIEW);
MyStocks.base.onActivated.call(this);
this.updateManager.startAsync(MyStocks.buildRequest(this.mySecurities),this,this._forceRefresh);
this._forceRefresh=false;
};
MyStocks.prototype.onDeactivated=function(){
this.updateManager.cancel();
MyStocks.base.onDeactivated.call(this);
};
MyStocks.log=Logger.getLogger("MyStocks");
