function MyStocksEdit(){
MyStocksEdit.baseConstructor.call(this,"my_stocks_edit","overflow");
if(!WrtHelper.isTouchEnabledDevice()){
var _1=$("my_stocks_edit");
_1.innerHTML+="<br><br><br>";
}
var _2=this;
this.addBtn=this.add("my_stocks_edit_add_btn");
this.addBtn.onclicked=function(){
var _3=_2.parent.get("stocks_search");
_3.displayForAdd();
};
this.doneBtn=this.add("my_stocks_edit_done_btn");
this.doneBtn.onclicked=function(){
_2.onDoneBtnClicked();
};
this._rows=new LinkedList.Circular();
};
Helper.extend(MyStocksEdit,DefNavigation);
MyStocksEdit.prototype.clearRows=function(){
var _4=$("my_stocks_edit_table");
this._rows.forEach(function(_5){
_4.removeChild(_5.row);
});
this._rows.clear();
};
MyStocksEdit.prototype.addSecurity=function(_6){
var _7=$("my_stocks_edit_table");
var tr=document.createElement("tr");
tr.className="item";
var td=document.createElement("td");
td.className="first";
td.innerHTML=_6.pxWBTKR;
tr.appendChild(td);
var _a=(_6.pxWBTKR.indexOf(":IND")!==-1);
td=document.createElement("td");
if(_a){
var _b=document.createTextNode(StringTable.StockSearch.NoMatch);
}else{
var _b=document.createElement("input");
_b.type="text";
_b.setAttribute("style","-wap-input-format: '*N'");
_b.value=_6.position;
this.add(_b);
}
td.appendChild(_b);
tr.appendChild(td);
td=document.createElement("td");
if(_a){
var _c=document.createTextNode(StringTable.StockSearch.NoMatch);
}else{
var _c=document.createElement("input");
_c.type="text";
_c.setAttribute("style","-wap-input-format: '*N'");
_c.value=_6.price;
this.add(_c);
}
td.appendChild(_c);
tr.appendChild(td);
td=document.createElement("td");
td.className="arrow";
td.innerHTML="<a href='#' class='delete_my_stock'></a>";
tr.appendChild(td);
var _d={row:tr,position:_b,price:_c,security:_6};
this._rows.append(_d);
var _e=this;
var _f=this.add(td);
_f._row=_d;
_f.onclicked=function(){
var row=this._row;
var _11=StringTable.MyStocksEdit.ConfirmDelete.replace(/%@/g,row.security.pxWBTKR);
var _12=confirm(_11);
if(_12){
AppStats.inc(AppStats.AppId.MY_STOCKS_DEL_FROM_PORTFOLIO);
_e._securities.deleteSecurity(row.security.pxWBTKR);
_7.removeChild(row.row);
_e._rows.remove(row);
}
};
_7.appendChild(tr);
};
MyStocksEdit.prototype.display=function(){
this.clearRows();
this._securities=new SecurityStorage();
this._securities.load();
AppStats.inc(AppStats.AppId.MY_STOCKS_EDIT_VIEW);
this.parent.activate(this.id);
for(var i=0;i<this._securities.size();++i){
this.addSecurity(this._securities.get(i));
}
};
MyStocksEdit.prototype.onDoneBtnClicked=function(){
this.processBackButton();
};
MyStocksEdit.prototype.processBackButton=function(){
try{
this._rows.forEach(function(row){
if(row.price.value===undefined&&row.position.value===undefined){
return;
}
var _15=parseFloat(row.price.value);
var _16=parseFloat(row.position.value);
if(isNaN(_15)||isNaN(_16)){
throw StringTable.MyStocksEdit.InvalidInput;
}
row.security.price=_15;
row.security.position=_16;
});
this._securities.save();
var _17=this.parent.get("my_stocks");
this._securities.load=function(){
};
_17.mySecurities=this._securities;
_17.setForceRefresh();
MyStocksEdit.base.processBackButton.call(this);
}
catch(err){
MyStocksEdit.log.error("Storing stock data failed.",err);
alert(err);
}
};
MyStocksEdit.prototype.onAddSecurity=function(_18){
AppStats.inc(AppStats.AppId.MY_STOCKS_ADD_TO_PORTFOLIO);
this._securities.addSecurity(_18,0,0);
this.addSecurity(this._securities.getSecurity(_18));
this.parent.activate(this.id);
};
MyStocksEdit.prototype.onDeactivated=function(){
this.setIgnoreBack();
MyStocksEdit.base.onDeactivated.call(this);
};
MyStocksEdit.log=Logger.getLogger("MyStocksEdit");
