function StockDetails(){
StockDetails.baseConstructor.call(this,"stocks_full","overflow");
this.graph=new AreaChart("chart_placeholder");
this.graphUpdateManager=new BAsyncJob(this.graph);
this.stockUpdateManager=new BAsyncJob(new XmlRequestBroker());
var _1=this;
this.stockUpdateManager.onSuccess=function(_2){
_1.onStockRefresh(_2);
};
this.stockUpdateManager.onError=function(_3){
_1.handleStockErrorResponse(_3);
};
if(WrtHelper.isTouchEnabledDevice()){
var _4=this.graph.getResizeHandler();
this.graph.setResizeHandler(function(e){
if(_1.isActive()&&WrtHelper.screenHeight()<WrtHelper.screenWidth()){
_1.displayGraphDetails();
}
_4.call(_1.graph);
});
}
};
Helper.extend(StockDetails,FormWithBack);
StockDetails.prototype.displayGraphDetails=function(){
var _6=this.parent.get("chart_full");
_6.display(this.pxWBTKR);
};
StockDetails.prototype.onActivated=function(){
AppStats.inc(AppStats.AppId.Q_SUMMARY_VIEW);
StockDetails.base.onActivated.call(this);
};
StockDetails.prototype.display=function(_7){
this.pxWBTKR=_7;
this.parent.activate(this.id);
if(!this.isActive()){
return;
}
this.type=this.getDisplayType(_7);
this.clear(false);
this.removeInjectedMenuItems();
$("stocks_full_name").innerHTML="";
$("stocks_full_current_value").innerHTML="";
$("stocks_full_net_change").innerHTML="";
$("stocks_full_percent_change").innerHTML="";
$("stocks_full_day_high").innerHTML="";
$("stocks_full_day_low").innerHTML="";
$("stocks_full_volume").innerHTML="";
$("stocks_full_time").innerHTML="";
$("stocks_full_graph_high").innerHTML="";
$("stocks_full_graph_low").innerHTML="";
$("stocks_graph_return").innerHTML="";
$("stocks_graph_pe").innerHTML="";
if(this.menuDescription){
this.setParagraphContent(this.menuDescription.element,"","");
}
if(this.menuNews){
this.setParagraphContent(this.menuNews.element,StringTable.StockDetails.NewsTitle,"");
}
this.menuGraph=this.add("chart_placeholder");
this.menuDescription=this.add("stocks_full_description",this.menuGraph);
var _8=this;
this.menuGraph.onclicked=function(){
if(WrtHelper.isTouchEnabledDevice()&&!WrtHelper.isLandscape()){
_8.graph.showMessage(StringTable.GraphDetails.RotateToViewFullScreen.replace(/\n/,"<br>"),3000);
}else{
_8.displayGraphDetails();
}
};
var _9=$("stocks_full_news");
var _a=$("button_group");
if(this.type==StockDetails.INDEX){
_a.show(true);
_9.show(false);
this.menuIndustryMovers=this.add("stocks_full_im",this.menuGraph);
this.menuIndustryMovers.onclicked=function(){
var _b=_8.parent.get("industry_movers");
_b.display(_8.pxWBTKR,$("stocks_full_name").innerHTML);
};
this.menuStockMovers=this.add("stocks_full_sm",this.menuIndustryMovers,this.menuDescription,this.menuIndustryMovers);
this.menuStockMovers.onclicked=function(){
var _c=_8.parent.get("stock_movers");
_c.display(_8.pxWBTKR,$("stocks_full_name").innerHTML);
};
}else{
if(this.type==StockDetails.STOCK){
_a.show(false);
_9.show(true);
this.menuNews=this.add("stocks_full_news",this.menuGraph,this.menuDescription);
this.menuNews.onclicked=function(){
var _d=_8.parent.get("stock_news");
_d.display($("stocks_full_name").innerHTML,_8.newsItems);
};
}else{
StockDetails.log.error("unknown display type: "+type);
}
}
this.setScrollerPos(0);
this.graph.init();
this.stockUpdateManager.startAsync(this.buildStockUrl(),this,true);
this.updateGraphData();
};
StockDetails.prototype.handleStockErrorResponse=function(_e){
};
StockDetails.prototype.setParagraphContent=function(_f,_10,_11){
_f.removeChildren();
var tr=document.createElement("tr");
var td=document.createElement("td");
td.className="about_title";
td.innerHTML=_10;
tr.appendChild(td);
_f.appendChild(tr);
tr=document.createElement("tr");
td=document.createElement("td");
td.className="about_description";
td.innerHTML=_11;
tr.appendChild(td);
_f.appendChild(tr);
};
StockDetails.prototype.onStockRefresh=function(xml){
var _15=xml.pxMarketData[0].pxCalcrt[0].pxSecurity[0];
$("stocks_full_name").innerHTML=_15.pxDS192;
this.setParagraphContent(this.menuDescription.element,_15.pxDS192,_15.pxDS318);
Utils.assignFormattedNumber($("stocks_full_current_value"),_15.pxPR005,2,Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("stocks_full_net_change"),_15.pxPR051,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES|Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("stocks_full_percent_change"),_15.pxPR052,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES|Utils.Format.PERCENT_SUFIX|Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("stocks_full_day_high"),_15.pxPR007,3,Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("stocks_full_day_low"),_15.pxPR008,3,Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("stocks_full_volume"),_15.pxPR013,0);
$("stocks_full_time").innerHTML="<strong>"+Utils.date2String(_15.pxUTIME)+"</strong>";
Utils.assignFormattedNumber($("stocks_full_graph_high"),_15.pxHS001,2,Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("stocks_full_graph_low"),_15.pxHS002,2,Utils.Format.TRIM_FRAC_ZERO);
Utils.assignFormattedNumber($("stocks_graph_return"),_15.pxRT012,2,Utils.Format.SET_STYLES|Utils.Format.TRIM_FRAC_ZERO|Utils.Format.PERCENT_SUFIX);
Utils.assignFormattedNumber($("stocks_graph_pe"),_15.pxRR900,2,Utils.Format.TRIM_FRAC_ZERO);
if(this.type==StockDetails.STOCK){
var _16=this;
if(!this.stockNewsUpdateManager){
this.stockNewsUpdateManager=new BAsyncJob(new XmlRequestBroker());
this.stockNewsUpdateManager.onSuccess=function(_17){
_16.onStockNewsRefresh(_17);
};
this.stockNewsUpdateManager.onError=function(_18){
_16.handleStockNewsErrorResponse(_18);
};
}
setTimeout(function(){
_16.stockNewsUpdateManager.startAsync(_16.buildNewsUrl(),_16,true);
},0);
}
};
StockDetails.prototype.buildStockUrl=function(){
return {path:"apps/wds/SecurityData.asp",query:{Securities:this.pxWBTKR,Outfields:"DS192,PR005,PR051,PR052,DS318,PR007,PR008,PR013,HS001,RT012,HS002,RR900,UTIME"}};
};
StockDetails.prototype.buildNewsUrl=function(){
return {path:"apps/wds.asp",query:{Request:"NewsData",Cat1Type:"tkr",Cat1:this.pxWBTKR,Outfields:"HL,UT,SID,SUM"}};
};
StockDetails.prototype.handleStockNewsErrorResponse=function(_19){
this.newsItems=null;
};
StockDetails.prototype.onStockNewsRefresh=function(xml){
var _1b="";
try{
this.newsItems=xml.wnWNews[0].wnSTORY;
var _1c=Math.min(3,this.newsItems.length);
for(var i=0;i<_1c;++i){
_1b+="<div>"+this.newsItems[i].wnHL+"</div>";
}
}
catch(err){
StockDetails.log.warn("Reading news failed.",err);
}
if(_1b.length==0){
_1b="<div>"+StringTable.StockDetails.NoNews+"</div>";
this.menuNews.onclicked=function(){
};
}
this.setParagraphContent(this.menuNews.element,StringTable.StockDetails.NewsTitle,_1b);
};
StockDetails.prototype.updateGraphData=function(){
this.graphUpdateManager._operationInProgress=false;
this.graphUpdateManager.startAsync(GraphDetails.buildGraphUrl(this.pxWBTKR),null,true);
};
StockDetails.prototype.onDeactivated=function(){
this.stockUpdateManager.cancel();
this.graphUpdateManager.cancel();
StockDetails.base.onDeactivated.call(this);
};
StockDetails.prototype.beforeActivatedFromHistory=function(ref){
if(this.pxWBTKR!==ref){
this.display(ref);
}
};
StockDetails.prototype.getCustomObjForHistory=function(){
return this.pxWBTKR;
};
StockDetails.prototype.getDisplayType=function(_1f){
var _20=StockDetails.STOCK;
var _21=_1f.split(":");
if((_21.length>0)&&(_21[_21.length-1]=="IND")){
_20=StockDetails.INDEX;
}
return _20;
};
StockDetails.prototype._processKeyEvent=function(key){
switch(key){
case Keyboard.KEY_1:
this.menuIndustryMovers.onclicked();
break;
case Keyboard.KEY_2:
this.menuStockMovers.onclicked();
break;
default:
StockDetails.base._processKeyEvent.call(this,key);
break;
}
};
StockDetails.log=Logger.getLogger("StockDetails");
StockDetails.INDEX=0;
StockDetails.STOCK=1;
