function StocksSearch(){
StocksSearch.baseConstructor.call(this,"stocks_search");
if(!WrtHelper.isTouchEnabledDevice()){
var _1=$("stocks_search");
_1.innerHTML+="<br><br><br>";
}
var _2=this;
this.updateManager=new BAsyncJob(new XmlRequestBroker());
this.updateManager.onSuccess=function(_3){
_2.refreshDisplay(_3);
};
this.updateManager.onError=function(_4){
_2.handleErrorResponse(_4);
};
this.clearScreen();
this._clearHistory=true;
};
Helper.extend(StocksSearch,DefNavigation);
StocksSearch.prototype.clearScreen=function(){
if(this.edit!=null){
this.remove("stocks_search_edit",false);
}
if(this.btn!=null){
this.remove("stocks_search_btn",false);
}
if(this._cancelBtn){
this.remove(this._cancelBtn.id,false);
}
this.clear();
if(this._cancelBtn){
this._setCancelBtn();
}
this.edit=this.add("stocks_search_edit");
this.btn=this.add("stocks_search_btn");
var _5=this;
this.btn.onclicked=function(){
_5.startSearch();
};
this.updateElementSelectedStatus(this.edit.element,false);
};
StocksSearch.prototype.startSearch=function(){
this.clearScreen();
var _6={path:"apps/wds/SymbolSearch.asp",query:{Query:this.edit.element.value,From:1,Count:10}};
this.updateManager.startAsync(_6,this,true);
};
StocksSearch.prototype.handleErrorResponse=function(_7){
};
StocksSearch.prototype.noMatch=function(_8){
var _9=document.createElement("tr");
var td=document.createElement("td");
td.colSpan=3;
td.className="nomatch";
td.innerHTML="<strong>"+StringTable.StockSearch.NoMatch+"</strong>";
_9.appendChild(td);
_8.appendChild(_9);
this.add(_9);
};
StocksSearch.prototype.refreshDisplay=function(_b){
var _c=$("stocks_search_table_message");
var _d=this.btn;
var _e=this;
var _f;
try{
_f=_b.pxMarketData[0].pxSymbolSearch[0].pxSecurity;
}
catch(err){
StocksSearch.log.warn("Invalid response received.",err);
_f=null;
}
if(_f==null){
this.noMatch(_c);
return;
}
for(var i=0;i<_f.length;++i){
var _11=_f[i];
var tr=this.createRow(_11);
_c.appendChild(tr);
_d=this.add(tr,_d);
_d.pxWBTKR=_11.pxWBTKR;
_d.onclicked=function(){
_e._itemClicked.call(_e);
};
}
};
StocksSearch.prototype.createRow=function(_13){
var _14=document.createElement("tr");
var td=document.createElement("td");
td.innerHTML=_13.pxWBTKR;
_14.appendChild(td);
td=document.createElement("td");
td.innerHTML=_13.pxDS520;
_14.appendChild(td);
td=document.createElement("td");
td.className="arrow";
td.innerHTML="<a href='#' class='stock_more'></a>";
_14.appendChild(td);
return _14;
};
StocksSearch.prototype.displayForAdd=function(){
this._clearHistory=false;
this.parent.activate(this.id);
this._itemClicked=function(){
this.setIgnoreBack();
var _16=this.parent.get("my_stocks_edit");
_16.onAddSecurity(this.activeItem.pxWBTKR);
};
this._setCancelBtn();
};
StocksSearch.prototype._setCancelBtn=function(){
var _17=this;
this._cancelBtn=this.add("stocks_search_exit_btn");
this._cancelBtn.element.show(true);
var _18="";
if(!WrtHelper.isTouchEnabledDevice()){
_18+="<a href='#'>";
}
_18+=StringTable.StockSearch.Cancel;
if(!WrtHelper.isTouchEnabledDevice()){
_18+="</a>";
}
this._cancelBtn.element.innerHTML=_18;
this._cancelBtn.onclicked=function(){
_17.setIgnoreBack();
_17.parent.activate("my_stocks_edit");
};
};
StocksSearch.prototype.onActivated=function(){
AppStats.inc(AppStats.AppId.STOCK_FINDER_VIEW);
if(this._clearHistory){
this.clearHistory();
this._clearHistory=true;
}
this._itemClicked=this._itemClickedHandler;
injectExitBtn("stocks_search_exit_btn");
StocksSearch.base.onActivated.call(this);
if(WrtHelper.isTouchEnabledDevice()){
this.edit.element.focus();
}
};
StocksSearch.prototype._itemClickedHandler=function(){
var _19=this.parent.get("stocks_full");
AppStats.inc(AppStats.AppId.Q_SUMMARY_VIEW_FROM_STOCK_FINDER);
_19.display(this.activeItem.pxWBTKR);
};
StocksSearch.prototype.onDeactivated=function(){
this.updateManager.cancel();
if(this._cancelBtn){
this.remove(this._cancelBtn.id,false);
this._cancelBtn=null;
}
StocksSearch.base.onDeactivated.call(this);
};
StocksSearch.log=Logger.getLogger("StocksSearch");
