function Container(id,_2){
this.id=id;
this.activeItem=null;
this._isActive=false;
this.items=new HashTable();
if(_2){
this.scroller=$(_2);
this.storedScrollerPos=0;
}
};
Container.prototype._createItem=function(id){
var _4=new Item(id);
this.items.put(_4.id,_4);
return _4;
};
Container.prototype.remove=function(id,_6){
var _7=this.items.get(id);
if(_7!=null){
if(_7==this.activeItem){
if(_7.up){
this.activate(_7.up);
}else{
if(_7.down){
this.activate(_7.down);
}else{
if(_7.left){
this.activate(_7.left);
}else{
if(_7.right){
this.activate(_7.right);
}else{
this.updateElementSelectedStatus(this.activeItem.element,false);
this.activeItem=null;
}
}
}
}
}
if(_7.up&&_7.up.down){
_7.up.down=_7.down;
}
if(_7.down&&_7.down.up){
_7.down.up=_7.up;
}
if(_7.left&&_7.left.right){
_7.left.right=_7.right;
}
if(_7.right&&_7.right.left){
_7.right.left=_7.left;
}
this.items.remove(id);
if(_6==null||_6){
_7.element.parentNode.removeChild(_7.element);
}
}
};
Container.prototype.clear=function(_8){
var it=this.items.iterator();
while(it.hasNext()){
this.remove(it.key(),_8);
it=this.items.iterator();
}
};
Container.prototype.isActive=function(){
return this._isActive;
};
Container.prototype._processKeyEvent=function(_a){
if(this.activeItem==null){
if(Container.log.isDebugEnabled()){
Container.log.debug("Container "+this.id+": no active item.");
}
return;
}
if(this._updateScroller(_a)){
return;
}
switch(_a){
case Keyboard.KEY_LEFT:
this.activate(this.activeItem.left);
break;
case Keyboard.KEY_RIGHT:
this.activate(this.activeItem.right);
break;
case Keyboard.KEY_UP:
this.activate(this.activeItem.up);
break;
case Keyboard.KEY_DOWN:
this.activate(this.activeItem.down);
break;
case Keyboard.KEY_ENTER:
this.activeItem._clicked();
break;
}
};
Container.prototype._updateScroller=function(_b){
if(this.scroller==null){
return false;
}
if(this.scroller.clientHeight<this.activeItem.element.offsetHeight){
if(_b==Keyboard.KEY_DOWN||_b==Keyboard.KEY_RIGHT){
if(Container.log.isDebugEnabled()){
Container.log.debug("Scroller KEY_DOWN: scroller.clientHeight "+this.scroller.clientHeight+" this.activeItem.offsetHeight "+this.activeItem.element.offsetHeight);
}
if(this.scroller.clientHeight<this.activeItem.element.offsetHeight){
var _c=this.scroller.clientHeight+this.scroller.scrollTop;
var _d=this.activeItem.element.offsetTop+this.activeItem.element.offsetHeight;
if(Container.log.isDebugEnabled()){
Container.log.debug("Scroller KEY_DOWN: visibleBottom "+_c+" itemBottom "+_d);
}
if(_c<_d){
var _e=(_b==Keyboard.KEY_DOWN)?Container.SCROLL_DELTA:this._getPageScrollSize();
var _f=this.scroller.scrollTop+_e;
if(_f>this.scroller.scrollHeight){
_f=this.scroller.scrollHeight;
}
this.scroller.scrollTop=_f;
return true;
}
}
}
if(_b==Keyboard.KEY_UP||_b==Keyboard.KEY_LEFT){
if(this.activeItem.element.offsetTop<this.scroller.scrollTop){
var _e=(_b==Keyboard.KEY_UP)?Container.SCROLL_DELTA:this._getPageScrollSize();
var _f=this.scroller.scrollTop-_e;
if(_f<0){
_f=0;
}
this.scroller.scrollTop=_f;
return true;
}
}
}
if(_b==Keyboard.KEY_UP&&this.activeItem&&this.activeItem.up==null){
if(this.activeItem.up==null){
this.scroller.scrollTop=0;
}
}
return false;
};
Container.prototype._getPageScrollSize=function(){
return Math.round(this.scroller.clientHeight*0.97);
};
Container.prototype.ensureVisible=function(_10){
if(this.scroller==null){
return;
}
if(_10==null){
return;
}
if(!isParentOf(_10.element,this.scroller)){
if(Container.log.isDebugEnabled()){
Container.log.debug("Scroller pane is ignoring activation event for "+_10.id+" since it is not placed in scroller element");
}
return;
}
if(this.scroller.clientHeight<_10.element.offsetHeight){
return;
}
var rv=this._calculateOffset(_10.element);
var _12=rv.element;
var _13=rv.offsetTop;
if(_13<this.scroller.scrollTop){
this.scroller.scrollTop=_13;
var _14=_12.offsetHeight-_12.clientHeight;
if(_14>0&&this.scroller.scrollTop>=_14){
if(Container.log.isDebugEnabled()){
Container.log.debug("Correcting scroller top for "+_14);
}
this.scroller.scrollTop-=_14;
}
}else{
var _15=this.scroller.clientHeight+this.scroller.scrollTop;
var _16=_13+_12.offsetHeight;
if(_15<_16){
this.scroller.scrollTop+=_16-_15;
}
}
};
Container.prototype._calculateOffset=function(_17){
var _18=0;
var tmp=_17;
if(tmp.nodeName=="TR"&&tmp.firstChild!=null){
_17=tmp.firstChild;
tmp=tmp.firstChild;
}
while(tmp!=null&&isParentOf(tmp,this.scroller)){
if(tmp.offsetTop){
_18+=tmp.offsetTop;
}
tmp=tmp.offsetParent;
}
return {offsetTop:_18,element:_17};
};
Container.prototype.activate=function(_1a){
if(_1a==null){
if(Container.log.isDebugEnabled()){
Container.log.debug("Container "+this.id+": no relation for given key.");
}
return;
}
if(this.activeItem){
this.updateElementSelectedStatus(this.activeItem.element,false);
}
this.activeItem=_1a;
this.updateElementSelectedStatus(this.activeItem.element,true);
this.ensureVisible(_1a);
};
Container.prototype.updateElementSelectedStatus=function(_1b,_1c){
$(_1b).setClassName(Container.ACTIVE_STYLE,_1c);
};
Container.prototype.setScrollerPos=function(pos){
if(this.scroller){
this.scroller.scrollTop=pos;
}
};
Container.prototype.onActivated=function(){
if(this.scroller){
var _1e=this.storedScrollerPos;
if(Container.log.isDebugEnabled()){
Container.log.debug("Restoring scroller pos for "+this.id+": "+_1e);
}
this.scroller.scrollTop=_1e;
}
this._isActive=true;
};
Container.prototype.onDeactivated=function(){
if(this.scroller){
this.storedScrollerPos=this.scroller.scrollTop;
if(Container.log.isDebugEnabled()){
Container.log.debug("Saving scroller pos for "+this.id+": "+this.storedScrollerPos);
}
this.scroller.scrollTop=0;
}
this._isActive=false;
};
Container.log=Logger.getLogger("Container");
Container.SCROLL_DELTA=20;
Container.ACTIVE_STYLE="activated";
Container.prototype.setTouchEnabled=function(_1f){
this.add=Container._getAdd(_1f);
};
Container._getAdd=function(_20){
if(_20){
return function(id,up,_23,_24,_25){
var _26=this._createItem(id);
var _27=this;
if(!WrtHelper.isWrt5OrLater()){
_26.element.onfocus=_26.element.onmouseover=function(){
_27.activate(_26);
};
}
_26.element.onclick=function(_28){
if(WrtHelper.isWrt5OrLater()){
_27.activate(_26);
}
_26._clicked(_28);
};
return _26;
};
}
return function(id,up,_2b,_2c,_2d){
var _2e=this._createItem(id);
if(this.activeItem==null){
this.activate(_2e);
}
if(_2b){
_2e.down=_2b;
_2b.up=_2e;
}
if(up){
_2e.up=up;
up.down=_2e;
}
if(_2d){
_2e.right=_2d;
_2d.left=_2e;
}
if(_2c){
_2e.left=_2c;
_2c.right=_2e;
}
return _2e;
};
};
Container.prototype.add=function(id,up,_31,_32,_33){
Container.prototype.add=Container._getAdd(WrtHelper.isTouchEnabledDevice());
return this.add(id,up,_31,_32,_33);
};
