var Updater={getVersion:function(){
return this._currentVersion;
},fetchLocalVersion:function(_1){
if(this._currentVersion){
_1();
return;
}
this._broker=new RequestBroker();
var _2=this;
this._broker.onSuccess=function(_3){
if(Updater.log.isDebugEnabled()){
Updater.log.debug("Got reponse for info.plist");
}
var _4=_3.responseXML.getElementsByTagName("dict")[0].childNodes;
for(i=0;i<_4.length;i++){
if(_4[i].nodeName.toLowerCase()=="key"){
if(_4[i].childNodes[0].nodeValue.toLowerCase()=="version"){
while(_4[i].nodeName!="string"&&i<_4.length){
++i;
}
if(Updater.log.isDebugEnabled()){
Updater.log.debug("Got version from info.plist: "+_4[i].childNodes[0].nodeValue);
}
_2._currentVersion=new Updater.Version(_4[i].childNodes[0].nodeValue);
$("about_version").innerHTML=StringTable.About.Version.replace(/%@/,_2._currentVersion);
break;
}
}
}
if(!_2._currentVersion){
Updater.log.error("Unable to read version from info.plist. Auto update is unable to check for new version.");
_2._currentVersion=new Updater.Version("0.0.0");
}
_1();
};
this._broker.onError=function(_5){
Updater.log.error("Reading version info from info.plist failed with status "+_5);
_2._currentVersion=new Updater.Version("0.0.0");
_1();
};
var _6="info.plist";
if(!WrtHelper.isWrt5OrLater()){
_6+="?"+new Date().getTime();
}
this._broker.startAsync(_6);
},startAsync:function(){
this._broker=new BAsyncJob(new XmlRequestBroker());
var _7=this;
this._broker.onSuccess=function(_8){
if(Updater.log.isDebugEnabled()){
Updater.log.debug("Got latest version: "+_8.NokiaVersion[0].Version);
}
_7._latestVersion=new Updater.Version(_8.NokiaVersion[0].Version);
_7._processUpdate(_8.NokiaVersion[0].Url);
};
this._broker.onError=function(_9){
Updater.log.error("Reading latest version info failed with status "+_9);
_7.onError(_9);
};
this._broker.startAsync(this.PATH);
},_processUpdate:function(_a){
if(Updater.log.isDebugEnabled()){
Updater.log.debug("Current version: "+this._currentVersion+", latest: "+this._latestVersion);
}
if(this._currentVersion.build()<this._latestVersion.build()){
var _b=confirm(StringTable.NewerVersionFound);
if(this._currentVersion.major()<this._latestVersion.major()||this._currentVersion.minor()<this._latestVersion.minor()){
Updater.log.info("Major upgrade detected.");
if(!_b){
alert(StringTable.OutdatedVersion);
window.close();
return;
}
}else{
Updater.log.info("Minor upgrade detected.");
}
if(_b){
if(Updater.log.isDebugEnabled()){
Updater.log.debug("Upgrading from: "+_a);
}
this._upgrade(_a);
return;
}
}
this.onSuccess();
},checkForPendingUpgrade:function(_c){
var _d=new RequestBroker();
var _e=this;
_d.onSuccess=function(_f){
var _10=_f.responseText;
if(Updater.log.isDebugEnabled()){
Updater.log.debug("Restoring configuration: '"+_10+"'");
}
if(_10.length>0){
_10=JSON.parse(_10);
for(var i=0;i<_10.length;++i){
var _12=_10[i];
if(Updater.log.isDebugEnabled()){
Updater.log.debug(_12.key+"="+_12.value);
}
if(_12.value.length>0){
widget.setPreferenceForKey(_12.value,_12.key);
}
}
var _13=new RequestBroker();
_13.onSuccess=_13.onError=function(){
};
_13.startAsync(GraphBroker.SERVER_ADDRESS+"/BloomCharts/settings?cName="+encodeURIComponent(Updater.COOKIE_NAME)+"&value=");
}
_c();
};
_d.onError=function(_14){
Updater.log.warn("Reading configuration cookie failed.");
_c();
};
_d.startAsync(GraphBroker.SERVER_ADDRESS+"/BloomCharts/settings?cName="+encodeURIComponent(Updater.COOKIE_NAME));
},_getPreference:function(key){
var _16=widget.preferenceForKey(key);
if(!_16){
_16="";
}
return _16;
},_upgrade:function(url){
var _18=[];
for(var i=0;i<this.KEYS4STORE.length;++i){
var _1a={key:this.KEYS4STORE[i],value:this._getPreference(this.KEYS4STORE[i])};
_18.push(_1a);
}
_18=JSON.stringify(_18);
if(Updater.log.isDebugEnabled()){
Updater.log.debug("Saving configuration: "+_18);
}
var _1b=new RequestBroker();
_1b.onSuccess=function(){
Updater.log.info("Configuration saved, performing upgrade...");
widget.openURL(url);
window.close();
};
_1b.onError=function(){
Updater.log.error("Unable to save configuration!");
widget.openURL(url);
window.close();
};
_1b.startAsync(GraphBroker.SERVER_ADDRESS+"/BloomCharts/settings?cName="+encodeURIComponent(Updater.COOKIE_NAME)+"&value="+encodeURIComponent(_18));
},PATH:"NokiaVersionService.asmx/GetCurrent",COOKIE_NAME:"bbStorage",KEYS4STORE:[FormWithBack.STICKY_PAGES_KEY,BAsyncJob.ID_KEY,SecurityStorage.WIDGET_STORAGE_KEY,NewsCategoriesStorage.KEY],log:Logger.getLogger("Updater")};
Updater.Version=function(_1c){
var ver=_1c.split(".");
this._major=(ver.length>0)?parseInt(ver[0]):0;
this._minor=(ver.length>1)?parseInt(ver[1]):0;
this._build=(ver.length>2)?parseInt(ver[2]):0;
};
Updater.Version.prototype={equal:function(ver){
return (ver.major()==this.major()&&ver.minor()==this.minor()&&ver.build()==this.build());
},major:function(){
return this._major;
},minor:function(){
return this._minor;
},build:function(){
return this._build;
},toString:function(){
return this.major()+"."+this.minor()+"."+this.build();
}};
