var uiManager;
var lastActiveScreenId=null;
function init(){
setCss();
updateLabels();
widget.setNavigationEnabled(false);
menu.hideSoftkeys();
uiManager=new UIManager();
uiManager.add(new MiniView());
uiManager.add(new RightMenu());
uiManager.setMenu(new Menu());
uiManager.showMenu(false);
onResize();
};
function setUpPages(){
var _1=new Markets();
var _2=new MyStocks();
var _3=new News();
var _4=new StocksSearch();
var _5=new About();
uiManager.add(_3);
uiManager.add(_2);
uiManager.add(_4);
uiManager.add(_1);
uiManager.add(new NewsDetails());
uiManager.add(new StockDetails());
uiManager.add(new StockNews());
uiManager.add(new StockMovers());
uiManager.add(new IndustryMovers());
uiManager.add(new GraphDetails());
uiManager.add(new MyStocksEdit());
uiManager.add(new NewsEdit());
uiManager.add(_5);
if(!WrtHelper.isTouchEnabledDevice()){
$("menu").show(true);
}
var _6=new MenuItem(StringTable.Menu.News,9001);
var _7=new MenuItem(StringTable.Menu.Markets,9002);
var _8=new MenuItem(StringTable.Menu.MyStocks,9003);
var _9=new MenuItem(StringTable.Menu.StockFinder,9004);
var _a=new MenuItem(StringTable.About.TopTitle,9005);
var _b=function(id){
return function(){
setTimeout(function(){
uiManager.activate(id);
},0);
};
};
_6.onSelect=_b(_3.id);
_7.onSelect=_b(_1.id);
_8.onSelect=_b(_2.id);
_9.onSelect=_b(_4.id);
_a.onSelect=_b(_5.id);
menu.append(_6);
menu.append(_7);
menu.append(_8);
menu.append(_9);
menu.append(_a);
uiManager.addCommand(new KeyCommand(Keyboard.KEY_7,function(){
uiManager.activate(_3.id);
}));
uiManager.addCommand(new KeyCommand(Keyboard.KEY_8,function(){
uiManager.activate(_1.id);
}));
uiManager.addCommand(new KeyCommand(Keyboard.KEY_9,function(){
uiManager.activate(_2.id);
}));
uiManager.addCommand(new KeyCommand(Keyboard.KEY_0,function(){
uiManager.activate(_4.id);
}));
uiManager.addCommand(new KeyCommand(Keyboard.KEY_HASH,function(){
uiManager.showMenu(!uiManager.menuActive);
}));
};
var MINI_VIEW_TRESHOLD=150;
var ViewMode={MiniView:1,NormalView:2};
var viewMode=null;
function getViewMode(){
return (window.innerHeight<MINI_VIEW_TRESHOLD)?ViewMode.MiniView:ViewMode.NormalView;
};
function setViewMode(){
function showView(_d){
$("container").show(!_d);
if(WrtHelper.isTouchEnabledDevice()){
$("buttons_bottom_landscape").show(!_d&&WrtHelper.screenHeight()<WrtHelper.screenWidth());
}
$("mini_view").show(_d);
};
if(getViewMode()===ViewMode.MiniView){
if(viewMode!=ViewMode.MiniView){
Logger.getRootLogger().info("MiniView mode detected!");
showView(true);
if(uiManager.activePage){
lastActiveScreenId=uiManager.activePage.id;
}
uiManager.activate("mini_view");
viewMode=ViewMode.MiniView;
}
}else{
if(viewMode!=ViewMode.NormalView){
Logger.getRootLogger().info("Full Screen mode detected!");
showView(false);
if(!lastActiveScreenId){
var _e=function(){
var _f=new AsyncJob(Updater);
_f.onSuccess=_f.onError=function(){
setUpPages();
$("startup").show(false);
var id=widget.preferenceForKey(FormWithBack.STICKY_PAGES_KEY);
if(!id){
id=news.id;
}
uiManager.activate(id);
};
_f.startAsync();
};
if(WrtHelper.isWrt5OrLater()){
setTimeout(_e,800);
}else{
_e();
}
}else{
uiManager.activate(lastActiveScreenId);
}
viewMode=ViewMode.NormalView;
}
}
};
function showing(){
setViewMode();
};
var bbHeight=null;
var bbWidth=null;
var lastViewMode=null;
var _configurationCookieRead=false;
function onResize(){
var _11=getViewMode();
if(WrtHelper.screenHeight()===bbHeight&&WrtHelper.screenWidth()===bbWidth&&_11===lastViewMode){
return;
}
lastViewMode=_11;
bbHeight=WrtHelper.screenHeight();
bbWidth=WrtHelper.screenWidth();
if(!_configurationCookieRead){
_configurationCookieRead=true;
Updater.checkForPendingUpgrade(onResizeHandler);
}else{
onResizeHandler();
}
};
function onResizeHandler(){
BAsyncJob.init(function(){
Updater.fetchLocalVersion(function(){
initialize();
setViewMode();
if(viewMode===ViewMode.MiniView){
onMiniViewResize();
}else{
onNormalViewResize();
}
});
});
};
var _initialized=false;
function initialize(){
if(!_initialized){
_initialized=true;
Ads.sendStats();
AppStats.sendStats();
}
};
function onNormalViewResize(){
var _12=$("container");
var _13=$("overflow");
var _14=screen.height;
var _15=screen.width;
_12.style.height=_14;
_12.style.width=_15;
var _16=_12.clientHeight;
if(!WrtHelper.isTouchEnabledDevice()){
_16-=18;
}
var _17=$("chart_placeholder");
var _18=Math.floor(_15/2);
var _19=Math.floor(_18/1.8);
_17.style.width=_18;
_17.style.height=_19;
var _1a=_15;
var _1b=_16;
if(WrtHelper.isLargeScreen()){
_1b-=94;
}else{
_1b-=62;
}
var _1c=$("chart_full_placeholder_day");
_1c.style.width=_1a;
_1c.style.height=_1b;
_1c=$("chart_full_placeholder_one_year");
_1c.style.width=_1a;
_1c.style.height=_1b;
_1c=$("chart_full_placeholder_six_month");
_1c.style.width=_1a;
_1c.style.height=_1b;
_1c=$("chart_full_placeholder_one_month");
_1c.style.width=_1a;
_1c.style.height=_1b;
_1c=$("chart_full_placeholder_five_years");
_1c.style.width=_1a;
_1c.style.height=_1b;
if(WrtHelper.isTouchEnabledDevice()){
var _1d=WrtHelper.isLandscape();
var _1e=$("buttons_bottom_landscape");
var _1f=$("ads_banner");
if(uiManager.activePage!=="chart_full"){
_1e.show(_1d);
$("menu").show(!_1d);
}
$("stocks_full").setClassName("landscape",_1d);
if(_1d){
_13.style.width=_15-_1e.offsetWidth;
_1a-=_1e.offsetWidth;
$("ads_banner").style.bottom="0px";
_1f.style.bottom="0px";
_1f.style.width=_13.style.width;
_17.style.height=_19*0.8;
}else{
_16=_16-75-27;
_13.style.width="100%";
_1f.style.bottom="102px";
_1f.style.width="100%";
}
}else{
_13.style.width="100%";
}
_13.style.height=_16;
var _20=$("content4DefNavigation");
_20.style.width=_13.style.width;
_20.style.height=_13.style.height;
var _21=$("industry_movers_chart_placeholder");
var _22=$("button_group_indu");
_21.style.width=_1a;
if(WrtHelper.isLargeScreen()){
_21.style.height=_16-58-63-44;
}else{
_21.style.height=_16-33-41-29;
}
};
function onMiniViewResize(){
var _23=window.innerHeight;
var _24=window.innerWidth;
var _25=$("mini_view");
_25.style.width=_24;
_25.style.height=_23;
var _26=$("miniview_graph_placeholder");
_26.style.width=150;
_26.style.height=_23-21;
};
var preloadedImages=new Array();
function preloadImage(){
if(document.images){
for(var i=0;i<arguments.length;i++){
var img=new Image();
img.src=arguments[i];
preloadedImages.push(img);
}
}
};
function preloadImages(){
preloadImage("images/button_bg.png","images/buttons_bg.png","images/buttons_landscape_bg.png","images/startup.png","images/shadow.png","images/button_news.png","images/pop_up_top_left.png","images/pop_up_top_right.png","images/pop_up_straight_left.png","images/pop_up_straight_right.png","images/pop_up_straight_bottom.png","images/pop_up_straight_top.png","images/pop_up_bottom_left.png","images/pop_up_bottom_right.png","images/pop_up_bg.png","images/button_stock_finder.png","images/button_my_stocks.png","images/button_markets.png","images/button_news.png","images/button_bottom_activated.png","images/delete.png","images/table_change_row.png","images/check.png","images/check_activated.png","images/button_arrow_up.png","images/button_add.png","images/button_bg_pressed.png","images/button_wide_pressed.png","images/delete_pressed.png","images/info_pressed.png","images/table_change_row_pressed.png","images/refresh.gif","images/refresh_trans.gif","images/button_wide2.png","images/button_wide2_pressed.png");
if(!WrtHelper.isWrt5OrLater()){
preloadImage("images/3_2/button_add.png","images/3_2/button_arrow_up.png","images/3_2/button_news.png","images/3_2/button_markets.png","images/3_2/button_my_stocks.png","images/3_2/button_stock_finder.png","images/3_2/startup.png","images/3_2/button_bg.png","images/3_2/button_bg_activated.png","images/3_2/buttons_bg.png","images/3_2/button_bottom_activated.png","images/3_2/bottom_line.png","images/3_2/check.png","images/3_2/check_activated.png","images/3_2/delete.png","images/3_2/delete_activated.png","images/3_2/button_wide_activated.png","images/3_2/button_double_left_active.png","images/3_2/button_double_right_activated.png");
}
};
function updateLabels(){
$("menu_news").firstChild.innerHTML=StringTable.Menu.News;
$("menu_market").firstChild.innerHTML=StringTable.Menu.Markets;
$("menu_stocks").firstChild.innerHTML=StringTable.Menu.MyStocks;
$("menu_search").firstChild.innerHTML=StringTable.Menu.StockFinder;
$("right_menu_news").firstChild.innerHTML=StringTable.Menu.News;
$("right_menu_market").firstChild.innerHTML=StringTable.Menu.Markets;
$("right_menu_stocks").firstChild.innerHTML=StringTable.Menu.MyStocks;
$("right_menu_search").firstChild.innerHTML=StringTable.Menu.StockFinder;
$("news_edit_done_btn").innerHTML=StringTable.Done;
$("news_edit_top_title").innerHTML=StringTable.News.TopTitle;
$("news_edit_choose_cat").innerHTML=StringTable.NewsEdit.ChooseCategories;
$("news_edit_btn").innerHTML=StringTable.Edit;
$("news_top_title").innerHTML=StringTable.News.TopTitle;
if(WrtHelper.isLargeScreen()){
$("stock_news_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("stock_news_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("stock_news_top_title").innerHTML=StringTable.News.TopTitle;
if(WrtHelper.isLargeScreen()){
$("news_details_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("news_details_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("news_details_top_title").innerHTML=StringTable.NewsDetails.TopTitle;
$("my_stocks_top_title").innerHTML=StringTable.MyStocks.TopTitle;
$("my_stocks_edit_btn").innerHTML=StringTable.Edit;
if(WrtHelper.isLargeScreen()){
$("my_stocks_edit_add_btn").innerHTML="<img src='images/button_add.png' />";
}else{
$("my_stocks_edit_add_btn").innerHTML="<img src='images/3_2/button_add.png' />";
}
$("my_stocks_edit_top_title").innerHTML=StringTable.MyStocksEdit.TopTitle;
$("my_stocks_edit_done_btn").innerHTML=StringTable.Done;
$("my_stocks_edit_table_ticker").innerHTML=StringTable.MyStocksEdit.TableTicker;
$("my_stocks_edit_table_position").innerHTML=StringTable.MyStocksEdit.TablePosition;
$("my_stocks_edit_table_price").innerHTML=StringTable.MyStocksEdit.TablePrice;
$("stocks_search_top_title").innerHTML=StringTable.StockSearch.TopTitle;
$("stocks_search_btn").innerHTML=StringTable.StockSearch.SearchBtn;
$("btn_one_day").innerHTML=StringTable.GraphDetails.OneDay;
$("btn_one_month").innerHTML=StringTable.GraphDetails.OneMonth;
$("btn_six_months").innerHTML=StringTable.GraphDetails.SixMonth;
$("btn_one_year").innerHTML=StringTable.GraphDetails.OneYear;
$("btn_five_years").innerHTML=StringTable.GraphDetails.FiveYears;
$("markets_top_title").innerHTML=StringTable.Markets.TopTitle;
$("markets_equity_label").innerHTML=StringTable.Markets.Equity;
$("markets_commodities_label").innerHTML=StringTable.Markets.Commodities;
$("markets_bonds_label").innerHTML=StringTable.Markets.Bonds;
$("markets_currencies_label").innerHTML=StringTable.Markets.Currencies;
if(WrtHelper.isLargeScreen()){
$("world_market_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("world_market_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("world_market_top_title").innerHTML=StringTable.Markets.Equity;
if(WrtHelper.isLargeScreen()){
$("markets_bonds_page_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("markets_bonds_page_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("markets_bonds_page_top_title").innerHTML=StringTable.Markets.Bonds;
if(WrtHelper.isLargeScreen()){
$("world_currencies_page_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("world_currencies_page_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("world_currencies_page_top_title").innerHTML=StringTable.Markets.Currencies;
if(WrtHelper.isLargeScreen()){
$("world_commodity_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("world_commodity_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("world_commodity_top_title").innerHTML=StringTable.Markets.Commodities;
if(WrtHelper.isLargeScreen()){
$("stocks_full_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("stocks_full_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("stocks_full_day_high_label").innerHTML=StringTable.StockDetails.High;
$("stocks_full_day_low_label").innerHTML=StringTable.StockDetails.Low;
$("stocks_full_volume_label").innerHTML=StringTable.StockDetails.Volume;
$("stocks_full_time_label").innerHTML=StringTable.StockDetails.Time;
$("stock_graph_title").innerHTML=StringTable.StockDetails.GraphTitle;
$("stocks_full_graph_high_label").innerHTML=StringTable.StockDetails.High52;
$("stocks_full_graph_low_label").innerHTML=StringTable.StockDetails.Low52;
$("stocks_graph_pe_label").innerHTML=StringTable.StockDetails.PE;
$("stocks_graph_return_label").innerHTML=StringTable.StockDetails.Return;
$("stocks_full_im").innerHTML=StringTable.StockDetails.IndustryMoversBtn;
$("stocks_full_sm").innerHTML=StringTable.StockDetails.StockMoversBtn;
$("stocks_full_news_title").innerHTML=StringTable.StockDetails.NewsTitle;
$("mini_view_current_label").innerHTML=StringTable.MiniView.Current;
$("mini_view_high_label").innerHTML=StringTable.StockDetails.High;
$("mini_view_low_label").innerHTML=StringTable.StockDetails.Low;
$("mini_view_time_label").innerHTML=StringTable.StockDetails.Time;
if(WrtHelper.isLargeScreen()){
$("stock_movers_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("stock_movers_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("stocks_movers_leaders").innerHTML=StringTable.StockMovers.Leaders;
$("stocks_movers_laggers").innerHTML=StringTable.StockMovers.Laggers;
if(WrtHelper.isLargeScreen()){
$("industry_movers_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("industry_movers_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("industry_movers_chart_button").innerHTML=StringTable.IndustryMovers.ChartBtn;
$("industry_movers_table_button").innerHTML=StringTable.IndustryMovers.TableBtn;
if(WrtHelper.isLargeScreen()){
$("about_back").innerHTML="<img src='images/button_arrow_up.png' />";
}else{
$("about_back").innerHTML="<img src='images/3_2/button_arrow_up.png' />";
}
$("about_top_title").innerHTML=StringTable.About.TopTitle;
$("about_content").innerHTML=StringTable.About.Content;
$("about_news_title").innerHTML=StringTable.About.NewsTitle;
$("about_news").innerHTML=StringTable.About.News;
$("about_markets_title").innerHTML=StringTable.About.MarketsTitle;
$("about_markets").innerHTML=StringTable.About.Markets;
$("about_mystocks_title").innerHTML=StringTable.About.MyStocksTitle;
$("about_mystocks").innerHTML=StringTable.About.MyStocks;
$("about_stocksfinder_title").innerHTML=StringTable.About.StocksFinderTitle;
$("about_stocksfinder").innerHTML=StringTable.About.StocksFinder;
$("about_feedback").innerHTML=StringTable.About.Feedback;
$("about_disclamer").innerHTML=StringTable.About.Disclamer;
$("button_mail_it").firstChild.src=WrtHelper.isLargeScreen()?"images/button_mail_it.png":"images/3_2/button_mail_it.png";
injectExitBtn("news_exit_btn");
injectExitBtn("my_stocks_exit_btn");
injectExitBtn("markets_exit_btn");
injectExitBtn("stocks_search_exit_btn");
var _29=$("chart_full_back_btn");
if(WrtHelper.isTouchEnabledDevice()){
_29.show(true);
}else{
var td=_29.parentNode;
td.parentNode.removeChild(td);
}
};
function injectExitBtn(id){
var _2c=$(id);
if(WrtHelper.isTouchEnabledDevice()){
_2c.innerHTML=StringTable.Exit;
_2c.show(true);
_2c.onclick=function(){
window.close();
};
}else{
_2c.show(false);
}
};
function setCss(){
document.styleSheets[0].disabled=!WrtHelper.isLargeScreen();
document.styleSheets[1].disabled=WrtHelper.isLargeScreen();
};
