NewsCategory=function(_1,_2){
this._label=_1;
this._url=_2;
this._isActive=false;
};
NewsCategory.prototype={getLabel:function(){
return this._label;
},getUrl:function(){
return this._url+".asp";
},isActive:function(){
return this._isActive;
},setActive:function(_3){
if(_3==null){
_3=true;
}
this._isActive=_3;
}};
var NewsCategoriesStorage={getActiveCategories:function(){
var _4=this.getAllCategories();
var _5=[];
for(var i=0;i<_4.length;++i){
var _7=_4[i];
if(_7.isActive()){
_5.push(_7);
}
}
return _5;
},getAllCategories:function(_8){
return this._categories;
},_parseCategories:function(_9){
var _a=_9.responseXML;
var _b=[];
var _c=_a.getElementsByTagName("ArrayOfString");
for(var i=0;i<_c.length;++i){
var _e=[];
var _f=_c[i].firstChild;
while(_f&&_e.length<2){
if(_f.nodeName=="string"){
_e.push(_f.firstChild.nodeValue);
}
_f=_f.nextSibling;
}
if(_e.length!=2){
NewsCategory.log.warn("Invalid news category item received.");
}else{
_b.push({label:_e[0],url:_e[1]});
}
}
return _b;
},load:function(_10,_11){
var _12=new BAsyncJob(new RequestBroker());
_12.setCacheFilter(NewsCategoriesStorage._parseCategories);
_12.enableCache();
var _13=this;
_12.onSuccess=function(_14){
_13._categories=[];
for(var i=0;i<_14.length;++i){
var _16=_14[i];
_13._categories.push(new NewsCategory(_16.label,_16.url));
}
var _17=[];
var _18=_13.getAllCategories();
var _19=widget.preferenceForKey(_13.KEY);
if(_19){
try{
_17=JSON.parse(_19);
}
catch(err){
NewsCategoriesStorage.log.error("Unable to load news categories.",err);
}
}
for(var i=0;i<_17.length;++i){
var _16=_13.getCategory(_17[i]);
if(_16){
_16.setActive();
}
}
if(_17.length===0){
_13._setDefault();
}
_10();
};
_12.onError=function(_1a){
_11(_1a);
};
_12.startAsync("news_categories.asmx/GetCategories",uiManager.get("news"));
},_setDefault:function(){
var _1b=this.getAllCategories();
var _1c=["Worldwide","Exclusive"];
for(var i=0;i<_1c.length;++i){
var _1e=this.getCategory(_1c[i]);
if(_1e){
_1e.setActive();
}
}
},save:function(_1f){
var _20=[];
this._categories=_1f;
for(var i=0;i<_1f.length;++i){
var cat=_1f[i];
if(cat.isActive()){
_20.push(cat.getLabel());
}
}
if(_20.length===0){
this._setDefault();
}
var _23=null;
try{
_23=JSON.stringify(_20);
}
catch(err){
NewsCategoriesStorage.log.error("Unable to stringify news categories.",err);
}
if(_23){
window.widget.setPreferenceForKey(_23,this.KEY);
}
},getCategory:function(_24){
var _25=this.getAllCategories();
for(var i=0;i<_25.length;++i){
var cat=_25[i];
if(cat.getLabel()==_24){
return cat;
}
}
return null;
},log:Logger.getLogger("NewsCategoriesStorage"),KEY:"blmbrg.news.categories"};
