function Markets(){
Markets.baseConstructor.call(this,"markets","overflow");
this._initPages();
};
Helper.extend(Markets,FormWithBack);
Markets.prototype._initPages=function(){
this._pages=[];
var _1=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.Name,function(td,_3){
td.innerHTML=MarketsPage._getCountry(_3.Country,_3.ShortName);
}),new DynamicHeaderTable.Column(StringTable.Markets.Ticker,function(td,_5){
td.innerHTML=MarketsPage._getCountry(_5.Country,_5.Id);
})]);
var _6=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.Last,function(td,_8){
Utils.assignFormattedNumber(td,_8.pxPR005,2);
})]);
var _9=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.PercentChange,function(td,_b){
Utils.assignFormattedNumber(td,_b.pxPR052,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.Markets.Change,function(td,_d){
Utils.assignFormattedNumber(td,_d.pxPR051,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.Markets.Time,function(td,_f){
td.className="";
td.innerHTML=Utils.date2String(_f.pxUTIME);
})]);
var _10={btnId:"markets_equity",pageId:"world_market",serviceName:"GetWeiData",tableId:"world_market_table",activeRows:true,columns:[_1,_6,_9]};
this._pages.push(_10);
var _1=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.Name,function(td,_12){
td.innerHTML=MarketsPage._getCountry(_12.Country,_12.ShortName);
}),new DynamicHeaderTable.Column(StringTable.Markets.Ticker,function(td,_14){
td.innerHTML=MarketsPage._getCountry(_14.Country,_14.Id);
})]);
var _6=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.Last,function(td,_16){
Utils.assignFormattedNumber(td,_16.pxPR005,2);
})]);
var _9=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.PercentChange,function(td,_18){
Utils.assignFormattedNumber(td,_18.pxPR052,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.Markets.Change,function(td,_1a){
Utils.assignFormattedNumber(td,_1a.pxPR051,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.Markets.Time,function(td,_1c){
td.className="";
td.innerHTML=Utils.date2String(_1c.pxUTIME);
})]);
var _1d={btnId:"markets_commodities",pageId:"world_commodity",serviceName:"GetWorldCommodityData",tableId:"world_commodity_table",columns:[_1,_6,_9]};
this._pages.push(_1d);
var _1=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.Name,function(td,_1f){
td.innerHTML=MarketsPage._getCountry(_1f.Country,_1f.ShortName);
}),new DynamicHeaderTable.Column(StringTable.Markets.Ticker,function(td,_21){
td.innerHTML=MarketsPage._getCountry(_21.Country,_21.Id);
})]);
var _6=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.Price,function(td,_23){
Utils.assignFormattedNumber(td,_23.pxPR005,2);
}),new DynamicHeaderTable.Column(StringTable.Markets.Yield,function(td,_25){
Utils.assignFormattedNumber(td,_25.pxYL004,2);
})]);
var _9=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.YldChg,function(td,_27){
Utils.assignFormattedNumber(td,_27.pxYL054,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.Markets.PrChg,function(td,_29){
Utils.assignFormattedNumber(td,_29.pxPR051,2,Utils.Format.PLUS_PREFIX|Utils.Format.SET_STYLES);
}),new DynamicHeaderTable.Column(StringTable.Markets.Time,function(td,_2b){
td.className="";
td.innerHTML=Utils.date2String(_2b.pxUTIME);
})]);
var _2c={btnId:"markets_bonds",pageId:"markets_bonds_page",serviceName:"GetWorldBondData",tableId:"markets_bonds_page_table",columns:[_1,_6,_9]};
this._pages.push(_2c);
var _1=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column(StringTable.Markets.Currencies,function(td,_2e){
td.innerHTML=MarketsPage._getCountry(_2e.Country,_2e.ShortName);
})]);
var _6=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column("USD",function(td,_30){
var val=(_30.USD.constructor==String)?_30.USD:1;
Utils.assignFormattedNumber(td,val,3);
})]);
var _9=new DynamicHeaderTable.ColumnCollection([new DynamicHeaderTable.Column("",function(){
}),new DynamicHeaderTable.Column("",function(){
})]);
var _32={btnId:"markets_currencies",pageId:"world_currencies_page",serviceName:"GetWorldCurrencyData",tableId:"world_currencies_page_table",columns:[_1,_6,_9],onAfterDataReceived:Markets._updateCurrenciesColumns};
this._pages.push(_32);
var _33=null;
var _34=this;
for(var i=0;i<this._pages.length;++i){
var _36=this._pages[i];
_33=this.add(_36.btnId,_33);
_33._index=i;
_33.onclicked=function(){
_34.showMarketsPage();
};
}
};
Markets.prototype.showMarketsPage=function(){
var _37=this._pages[this.activeItem._index];
if(!this[_37.btnId]){
this[_37.btnId]=new MarketsPage(_37);
uiManager.add(this[_37.btnId]);
}
this.parent.activate(_37.pageId);
};
Markets._showSelectedCurrencyColumn=function(td,_39){
var _3a=this._keyName;
var val=(_39[_3a]&&_39[_3a].constructor===String)?_39[_3a]:1;
Utils.assignFormattedNumber(td,val,3);
};
Markets._updateCurrenciesColumns=function(_3c,xml){
var _3e=_3c.getColumnCollection(2);
_3e.clear();
var _3f=xml.WMData[0].Groups[0].Group[0].Securities[0].Security[0].Values[0].SerializableStringPair;
for(var i=0;i<_3f.length;++i){
var key=new String(_3f[i].key);
if(key.toLowerCase()==="usd"){
continue;
}
var col=new DynamicHeaderTable.Column(key,Markets._showSelectedCurrencyColumn);
col._keyName=key;
_3e.add(col);
}
_3c.refreshHeader(2);
};
Markets.prototype.onActivated=function(_43,xml){
AppStats.inc(AppStats.AppId.MKT_MENU_VIEW);
this.clearHistory();
Markets.base.onActivated.call(this);
};
