function News(){
News.baseConstructor.call(this,"news","overflow");
this._counter=0;
this.updateManager=new BAsyncJob(new FeedBroker());
this.updateManager.setCacheFilter(function(_1){
var rv=[];
for(var i=0;i<_1.length;++i){
var _4=_1[i];
var o={};
for(var n in _4){
var _7=_4[n];
if(typeof _7!=="function"&&n&&n.length>0&&n.charAt(0)!=="_"){
o[n]=_7;
}
}
rv.push(o);
}
return rv;
});
this.updateManager.enableCache();
var _8=this;
this.updateManager.onSuccess=function(_9,_a){
_8.onCategoryReceived(_9,_a);
};
this.updateManager.onError=function(_b){
_8.handleErrorResponse(_b);
};
this.clearScreen();
};
Helper.extend(News,FormWithBack);
News.prototype.handleErrorResponse=function(_c){
};
News.prototype.clearScreen=function(){
this.remove("news_edit_btn",false);
this.removeInjectedMenuItems();
this.clear();
$("news_table").removeChildren();
this.editNewsBtn=this.add("news_edit_btn");
var _d=this;
this.editNewsBtn.onclicked=function(){
_d.parent.activate("news_edit");
};
this._prev=this.editNewsBtn;
};
News.prototype.setForceRefresh=function(){
this._forceRefresh=true;
};
News.prototype.addCategory=function(_e,_f){
var _10=this;
var _11=$("news_table");
if(News.log.isDebugEnabled()){
News.log.debug("Refreshing display "+_e.length);
}
News.createHeadline(_11,_f);
for(var i=0;i<_e.length;++i){
var _13=_e[i];
var row=News.createRow(_13);
_11.appendChild(row);
var _15=this.add(row,this._prev);
_15.guid=_13.guid;
_15.onclicked=function(){
_10.showDetails();
};
if(this._prev==this.editNewsBtn&&!WrtHelper.isTouchEnabledDevice()){
this.activate(_15);
}
this._prev=_15;
this._newsUrls.push(_13.guid);
}
};
News.prototype.showDetails=function(){
var _16=this.parent.get("news_details");
AppStats.inc(AppStats.AppId.NEWS_ARTICLE_VIEW);
_16.display(this.activeItem.guid);
};
News.createHeadline=function(_17,_18){
var tr=document.createElement("tr");
tr.className="table_title";
var td=document.createElement("td");
td.colSpan=2;
td.innerHTML=_18;
tr.appendChild(td);
_17.appendChild(tr);
};
News.createRow=function(_1b){
var _1c=new Date(_1b.pubDate);
var tr=document.createElement("tr");
tr.className="item";
var td=document.createElement("td");
td.className="news";
tr.appendChild(td);
var _1f="<div class='news_title'>"+_1b.title+"</div>";
_1f+="<div class='news_details'>";
_1f+="<div class='news_date'>"+Utils.formatDateOnly(_1c)+"</div>";
_1f+="<div class='news_ago'>"+Utils.formatDate(_1c)+"</div>";
_1f+="<div class='clear'></div>";
_1f+="</div>";
td.innerHTML=_1f;
td=document.createElement("td");
td.className="arrow";
td.innerHTML="<a href='#' class='news_more'></a>";
tr.appendChild(td);
return tr;
};
News.prototype.onActivated=function(){
AppStats.inc(AppStats.AppId.NEWS_HEADLINES_VIEW);
this.clearHistory();
News.base.onActivated.call(this);
if(!this._categoriesLoaded){
var _20=this;
NewsCategoriesStorage.load(function(){
_20._categoriesLoaded=true;
_20._fetchNews();
},function(){
});
}else{
this._fetchNews();
}
};
News.prototype._fetchNews=function(){
this._categories=NewsCategoriesStorage.getActiveCategories();
if(this._categories.length>0){
this._firstCategoryReceived=false;
this.onCategoryReceived();
}else{
this.clearScreen();
}
};
News.prototype.onCategoryReceived=function(xml,_22){
if(xml){
if(!this._firstCategoryReceived){
this.clearScreen();
this._firstCategoryReceived=true;
this._newsUrls=[];
}
var _23=this._categories.shift();
this.addCategory(xml,_23.getLabel());
}
if(this._categories.length>0){
var rv=this.updateManager.startAsync("apps/wds/news/"+this._categories[0].getUrl(),this,this._forceRefresh||this._firstCategoryReceived);
if(!rv&&!this._firstCategoryReceived){
++this._counter;
}
}else{
this._forceRefresh=false;
if(_22){
return;
}
this._performCleanup();
var _25=this;
setTimeout(function(){
_25._fetchNextStory();
},0);
}
};
News.prototype._fetchNextStory=function(){
var _26=this._counter;
var _27=function(){
if(_26!=this._counter){
News.log.debug("New news fetch in progress detected, canceling news download.");
return;
}
if(this._newsUrls.length>0){
if(this.isActive()){
var _28=this._newsUrls.length;
var _29=(_28===1)?StringTable.News.DownloadingArticle:StringTable.News.DownloadingArticles;
AsyncJob._showProgressOnPage(true);
Utils.updateStatusLabels(_29.replace(/%d/,_28));
}
var url=this._newsUrls.pop();
var _2b=this;
this._fetchNextStoryBroker=NewsDetails.getBroker();
this._fetchNextStoryBroker.onSuccess=this._fetchNextStoryBroker.onError=function(){
_27.call(_2b);
};
this._fetchNextStoryBroker.startAsync(url);
}else{
this._fetchNextStoryBroker=null;
if(this.isActive()){
AsyncJob._showProgressOnPage(false);
Utils.updateStatusLabel(this.lastUpdatedTime);
}
}
};
_27.call(this);
};
News._contains=function(_2c,str){
for(var i=0;i<_2c.length;++i){
if(_2c[i]==str){
return true;
}
}
return false;
};
News.prototype._performCleanup=function(){
var _2f=[];
for(var i=0;i<this._newsUrls.length;++i){
_2f.push(BAsyncJob.hashFromName123(this._newsUrls[i]+"&"));
}
setTimeout(function(){
var _31=widget.preferenceForKey(News.STORED_NEWS_KEY);
if(_31){
_31=JSON.parse(_31);
for(var i=0;i<_31.length;++i){
var key=_31[i];
if(!News._contains(_2f,key)){
if(News.log.isDebugEnabled()){
News.log.debug("Removing story with hash "+key);
}
widget.setPreferenceForKey(null,key);
}
}
}
widget.setPreferenceForKey(JSON.stringify(_2f),News.STORED_NEWS_KEY);
},0);
};
News.prototype.onDeactivated=function(){
this.updateManager.cancel();
News.base.onDeactivated.call(this);
};
News.log=Logger.getLogger("News");
News.STORED_NEWS_KEY="blmbrg.news.storage.keys";
