function NewsDetails(){
NewsDetails.baseConstructor.call(this,"news_details","overflow");
this.updateManager=NewsDetails.getBroker();
var _1=this;
this.updateManager.onSuccess=function(_2){
_1.refreshDisplay(_2);
};
this.updateManager.onError=function(_3){
_1.handleErrorResponse(_3);
};
this._injectBackButton();
this.newsPlaceholder=this.add("news_details_placeholder");
this.sendLinkBtn=this.add("button_mail_it",this.backBtn,this.newsPlaceholder,this.backBtn);
this.sendLinkBtn.onclicked=function(){
if(!_1._title||!_1._desc){
alert(StringTable.NoNewsDetailsToMail);
}else{
var _4=document.createElement("div");
_4.innerHTML=_1._desc;
var _5=_4.textContent;
_4=null;
if(!_5){
_5=_1._desc;
}
_5=_5.replace(/ +/g," ");
var _6=StringTable.MailBodyPrefix.replace(/%@/,"Nokia phone");
var _7="mailto:?subject="+encodeURIComponent(_1._title)+"&body="+encodeURIComponent(_6)+encodeURIComponent("\r\n\r\n")+encodeURIComponent(_5);
Utils.doAction(_7);
}
};
};
Helper.extend(NewsDetails,FormWithBack);
NewsDetails.getBroker=function(){
var _8=new BAsyncJob(new FeedBroker());
_8.enableCache(true);
_8.setCacheFilter(function(_9){
return [{title:_9[0].title,description:_9[0].description}];
});
return _8;
};
NewsDetails.prototype.display=function(_a){
this.parent.activate(this.id);
this.setScrollerPos(0);
this.updateManager.startAsync(_a,this,true);
};
NewsDetails.prototype.handleErrorResponse=function(_b){
this.newsPlaceholder.element.innerHTML="";
this._title=this._desc=null;
};
NewsDetails.prototype.refreshDisplay=function(_c){
this.activate(this.newsPlaceholder);
this._title=_c[0].title;
this._desc=_c[0].description;
this.newsPlaceholder.element.innerHTML="<h1>"+_c[0].title+"</h1>"+_c[0].description;
Ads.showBanner(this);
};
NewsDetails.prototype.onDeactivated=function(){
this.updateManager.cancel();
Ads.hideBanner();
NewsDetails.base.onDeactivated.call(this);
this.newsPlaceholder.element.innerHTML="";
};
NewsDetails.log=Logger.getLogger("NewsDetails");
