function UIManager(){
this.activePage=null;
this.menu=null;
this.menuActive=false;
var _1=this;
this.slide=new SimpleSlide();
this.pages=[];
this.keyCommands=[];
if(!WrtHelper.isTouchEnabledDevice()){
this._hookKeyboard();
}
};
UIManager.prototype.addCommand=function(_2){
this.keyCommands[_2.key]=_2;
};
UIManager.prototype.setMenu=function(_3){
this.menu=_3;
_3.parent=this;
};
UIManager.prototype.getMenu=function(){
return this.menu;
};
UIManager.prototype.showMenu=function(_4){
if(_4==null){
_4=true;
}
if(this.menu&&this.menuActive!=_4){
if(UIManager.log.isDebugEnabled()){
UIManager.log.debug("Update menu ["+this.menu.id+"]: "+_4);
}
this.menuActive=_4;
this.slide.slide(this.menu.id,_4);
if(this.menuActive){
this.menu.onActivated();
}else{
this.menu.onDeactivated();
}
}
};
UIManager.prototype.add=function(_5){
this.pages[_5.id]=_5;
_5.parent=this;
return _5;
};
UIManager.prototype.get=function(_6){
return this.pages[_6];
};
UIManager.prototype.transition=function(_7,_8){
if(_8){
if(UIManager.log.isDebugEnabled()){
UIManager.log.debug("Hiding page "+_8.id);
}
$(_8.id).show(false);
}
if(UIManager.log.isDebugEnabled()){
UIManager.log.debug("Showing page "+_7.id);
}
$(_7.id).show(true);
},UIManager.prototype.activate=function(id){
var _a=this.pages[id];
if(_a==null){
UIManager.log.error("Page "+id+" does not exist!");
return;
}
if(this.activePage&&this.activePage.id==id){
if(UIManager.log.isDebugEnabled()){
UIManager.log.debug("The page "+id+" is already activated.");
}
return;
}
if(this.activePage){
this.activePage.onDeactivated();
}
this.transition(_a,this.activePage);
this.activePage=_a;
this.activePage.onActivated();
};
UIManager.prototype._hookKeyboard=function(){
var _b=this;
document.onkeypress=function(_c){
function translateKey(_d){
var _e=_d.keyCode;
if(_e==63557||_e==13){
return (Keyboard.KEY_ENTER);
}
if(_e==63497||_e==38){
return (Keyboard.KEY_UP);
}
if(_e==63498||_e==40){
return (Keyboard.KEY_DOWN);
}
if(_e==63495||_e==37){
return (Keyboard.KEY_LEFT);
}
if(_e==63496||_e==39){
return (Keyboard.KEY_RIGHT);
}
if(_e==48||_e==109){
return (Keyboard.KEY_0);
}
if(_e==49||_e==114){
return (Keyboard.KEY_1);
}
if(_e==50||_e==116){
return (Keyboard.KEY_2);
}
if(_e==51||_e==121){
return (Keyboard.KEY_3);
}
if(_e==52||_e==102){
return (Keyboard.KEY_4);
}
if(_e==53||_e==103){
return (Keyboard.KEY_5);
}
if(_e==54||_e==104){
return (Keyboard.KEY_6);
}
if(_e==55||_e==118){
return (Keyboard.KEY_7);
}
if(_e==56||_e==98){
return (Keyboard.KEY_8);
}
if(_e==57||_e==110){
return (Keyboard.KEY_9);
}
if(_e==42||_e==117){
return (Keyboard.KEY_STAR);
}
if(_e==35||_e==106){
return (Keyboard.KEY_HASH);
}
};
var _f=translateKey(_c);
if(UIManager.log.isDebugEnabled()){
UIManager.log.debug("Pressed key "+_f);
}
try{
var _10=_b.keyCommands[_f];
if(_10!=null){
_10.keyPressed();
}else{
if(_b.menuActive){
_b.menu._processKeyEvent(_f);
}else{
if(_b.activePage){
_b.activePage._processKeyEvent(_f);
}
}
}
}
catch(ex){
UIManager.log.error("Processing key event failed.",ex);
}
};
};
UIManager.log=Logger.getLogger("UIManager");
