﻿StringTable.About.Content="More than 280,000 professionals around the world trust Bloomberg to give accurate and timely information about the world's financial markets";
StringTable.About.Disclamer="The information for these tools comes from the BLOOMBERG PROFESSIONAL&reg; service, through the BLOOMBERG.COM&reg; website. Data is delayed.\n\n&copy; 2009 Bloomberg Finance L.P.";
StringTable.About.Feedback="Questions or feedback";
StringTable.About.Markets="Find the latest information on the major equity, commodity, bond and currency markets. Drill down to see which industries and which stocks are driving the equity index.";
StringTable.About.MarketsTitle="Markets";
StringTable.About.MyStocks="Stay on top of your stock holdings. Enter your stock, number held and price bought at. Bloomberg will display the current price, change and market value of your holding.";
StringTable.About.MyStocksTitle="My stocks";
StringTable.About.News="Read the news that is moving the markets. These Bloomberg News stories are selected by our editors as the most important stories of the day.";
StringTable.About.NewsTitle="News";
StringTable.About.StocksFinder="Get the latest information on any listed stock. Bloomberg will display the latest market data and news for the stock.";
StringTable.About.StocksFinderTitle="Stock finder";
StringTable.About.TopTitle="About";
StringTable.About.Version="Version %@";
StringTable.Billions="%.2fB";
StringTable.ConfirmFollowUrl="Open website";
StringTable.DaysAgo="1 day ago";
StringTable.DaysAgoPlural="%d days ago";
StringTable.Done="Save";
StringTable.Downloading="Downloading";
StringTable.Edit="Edit";
StringTable.Exit="Exit";
StringTable.GraphDetails.At="at";
StringTable.GraphDetails.FiveYears="5 years";
StringTable.GraphDetails.High="High";
StringTable.GraphDetails.Last="Last";
StringTable.GraphDetails.Low="Low";
StringTable.GraphDetails.On="on";
StringTable.GraphDetails.OneDay="1 day";
StringTable.GraphDetails.OneMonth="1 month";
StringTable.GraphDetails.OneYear="1 year";
StringTable.GraphDetails.Open="Open";
StringTable.GraphDetails.RotateToViewFullScreen="Rotate to view\nfull screen";
StringTable.GraphDetails.SixMonth="6 months";
StringTable.HourAgo="1 hour ago";
StringTable.HourAgoPlural="%d hours ago";
StringTable.IndustryMovers.Category="Category";
StringTable.IndustryMovers.ChartBtn="Chart";
StringTable.IndustryMovers.ClassificationInfoUnavail="Classification information unavailable.\nTry another index.";
StringTable.IndustryMovers.Last="Last";
StringTable.IndustryMovers.PercentChange="% change";
StringTable.IndustryMovers.TableBtn="Table";
StringTable.MailBodyPrefix="Bloomberg news, sent from my %@";
StringTable.Markets.Bonds="Bonds";
StringTable.Markets.Change="Change";
StringTable.Markets.Commodities="Commodities";
StringTable.Markets.Currencies="Currencies";
StringTable.Markets.Equity="Equity indices";
StringTable.Markets.Last="Last";
StringTable.Markets.Name="Name";
StringTable.Markets.PercentChange="% change";
StringTable.Markets.PrChg="Price change";
StringTable.Markets.Price="Price";
StringTable.Markets.Ticker="Ticker";
StringTable.Markets.Time="Time";
StringTable.Markets.TopTitle="Markets";
StringTable.Markets.Yield="Yield";
StringTable.Markets.YldChg="Yield change";
StringTable.Menu.Markets="Markets";
StringTable.Menu.Menu="Menu";
StringTable.Menu.MyStocks="My stocks";
StringTable.Menu.News="News";
StringTable.Menu.StockFinder="Search";
StringTable.Millions="%.2fM";
StringTable.MiniView.Current="Current";
StringTable.MinuteAgo="1 minute ago";
StringTable.MinuteAgoPlural="%d minutes ago";
StringTable.Months[0]="Jan";
StringTable.Months[9]="Oct";
StringTable.Months[10]="Nov";
StringTable.Months[11]="Dec";
StringTable.Months[1]="Feb";
StringTable.Months[2]="Mar";
StringTable.Months[3]="Apr";
StringTable.Months[4]="May";
StringTable.Months[5]="Jun";
StringTable.Months[6]="Jul";
StringTable.Months[7]="Aug";
StringTable.Months[8]="Sep";
StringTable.MyStocks.BoughtAt="Bought at";
StringTable.MyStocks.Change="Change";
StringTable.MyStocks.Last="Last";
StringTable.MyStocks.Name="Name";
StringTable.MyStocks.PercentChange="% change";
StringTable.MyStocks.Position="Position";
StringTable.MyStocks.P_L="P & L";
StringTable.MyStocks.Ticker="Ticker";
StringTable.MyStocks.Time="Time";
StringTable.MyStocks.TopTitle="My stocks";
StringTable.MyStocks.Value="Value";
StringTable.MyStocks.ValueChg="Value change";
StringTable.MyStocksEdit.ConfirmDelete="Are you sure you want to delete %@?";
StringTable.MyStocksEdit.InvalidInput="Only numbers allowed";
StringTable.MyStocksEdit.TablePosition="Position";
StringTable.MyStocksEdit.TablePrice="Price";
StringTable.MyStocksEdit.TableTicker="Ticker";
StringTable.MyStocksEdit.TopTitle="My stocks";
StringTable.NetworkError="Connection error";
StringTable.NewerVersionFound="A newer version is available. Do you want to upgrade?";
StringTable.News.DownloadingArticle="Downloading 1 article";
StringTable.News.DownloadingArticles="Downloading %d articles";
StringTable.News.TopTitle="News headlines";
StringTable.NewsDetails.TopTitle="News";
StringTable.NewsEdit.CategoriesLimit="Only 5 categories can be selected";
StringTable.NewsEdit.ChooseCategories="Choose and order categories";
StringTable.NoInternetConnection="No internet connection";
StringTable.NoNewsDetailsToMail="This message cannot be forwarded";
StringTable.OutdatedVersion="Your version is not supported. Please upgrade to newest version.";
StringTable.StockDetails.GraphTitle="52-week summary";
StringTable.StockDetails.High="High";
StringTable.StockDetails.High52="High";
StringTable.StockDetails.IndustryMoversBtn="Industry movers";
StringTable.StockDetails.Low="Low";
StringTable.StockDetails.Low52="Low";
StringTable.StockDetails.NewsTitle="Related news";
StringTable.StockDetails.NoNews="No headlines";
StringTable.StockDetails.PE="P/E";
StringTable.StockDetails.Return="Return";
StringTable.StockDetails.StockMoversBtn="Stock movers";
StringTable.StockDetails.Time="Time";
StringTable.StockDetails.Volume="Volume";
StringTable.StockMovers.Change="Change";
StringTable.StockMovers.Laggers="Laggers";
StringTable.StockMovers.Last="Last";
StringTable.StockMovers.Leaders="Leaders";
StringTable.StockMovers.PercentChange="% change";
StringTable.StockMovers.Stock="Stock";
StringTable.StockMovers.Ticker="Ticker";
StringTable.StockMovers.Time="Time";
StringTable.StockSearch.Cancel="Cancel";
StringTable.StockSearch.NoMatch="N/A";
StringTable.StockSearch.SearchBtn="Search";
StringTable.StockSearch.TopTitle="Stock finder";
StringTable.Trillions="%.2fT";
StringTable.Updated="Data downloaded: %@";
